/*
 * Copyright 2012-2017 CodeLibs Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.codelibs.fess.es.log.cbean.ca.bs;

import org.codelibs.fess.es.log.allcommon.EsAbstractConditionAggregation;
import org.codelibs.fess.es.log.allcommon.EsAbstractConditionQuery;
import org.codelibs.fess.es.log.cbean.ca.SearchFieldLogCA;
import org.codelibs.fess.es.log.cbean.cq.SearchFieldLogCQ;
import org.codelibs.fess.es.log.cbean.cq.bs.BsSearchFieldLogCQ;
import org.elasticsearch.search.aggregations.bucket.filter.FilterAggregationBuilder;
import org.elasticsearch.search.aggregations.bucket.global.GlobalBuilder;
import org.elasticsearch.search.aggregations.bucket.missing.MissingBuilder;
import org.elasticsearch.search.aggregations.bucket.range.ipv4.IPv4RangeBuilder;
import org.elasticsearch.search.aggregations.bucket.sampler.SamplerAggregationBuilder;
import org.elasticsearch.search.aggregations.bucket.significant.SignificantTermsBuilder;
import org.elasticsearch.search.aggregations.bucket.terms.TermsBuilder;
import org.elasticsearch.search.aggregations.metrics.cardinality.CardinalityBuilder;
import org.elasticsearch.search.aggregations.metrics.scripted.ScriptedMetricBuilder;
import org.elasticsearch.search.aggregations.metrics.tophits.TopHitsBuilder;
import org.elasticsearch.search.aggregations.metrics.valuecount.ValueCountBuilder;

/**
 * @author ESFlute (using FreeGen)
 */
public abstract class BsSearchFieldLogCA extends EsAbstractConditionAggregation {

    // ===================================================================================
    //                                                                     Aggregation Set
    //                                                                           =========

    public void filter(String name, EsAbstractConditionQuery.OperatorCall<BsSearchFieldLogCQ> queryLambda,
            ConditionOptionCall<FilterAggregationBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        SearchFieldLogCQ cq = new SearchFieldLogCQ();
        if (queryLambda != null) {
            queryLambda.callback(cq);
        }
        FilterAggregationBuilder builder = regFilterA(name, cq.getQuery());
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void global(String name, ConditionOptionCall<GlobalBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        GlobalBuilder builder = regGlobalA(name);
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void sampler(String name, ConditionOptionCall<SamplerAggregationBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        SamplerAggregationBuilder builder = regSamplerA(name);
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void scriptedMetric(String name, ConditionOptionCall<ScriptedMetricBuilder> opLambda) {
        ScriptedMetricBuilder builder = regScriptedMetricA(name);
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void topHits(String name, ConditionOptionCall<TopHitsBuilder> opLambda) {
        TopHitsBuilder builder = regTopHitsA(name);
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    // String name

    public void setName_Terms() {
        setName_Terms(null);
    }

    public void setName_Terms(ConditionOptionCall<TermsBuilder> opLambda) {
        setName_Terms("name", opLambda, null);
    }

    public void setName_Terms(ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setName_Terms("name", opLambda, aggsLambda);
    }

    public void setName_Terms(String name, ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        TermsBuilder builder = regTermsA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setName_SignificantTerms() {
        setName_SignificantTerms(null);
    }

    public void setName_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda) {
        setName_SignificantTerms("name", opLambda, null);
    }

    public void setName_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setName_SignificantTerms("name", opLambda, aggsLambda);
    }

    public void setName_SignificantTerms(String name, ConditionOptionCall<SignificantTermsBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        SignificantTermsBuilder builder = regSignificantTermsA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setName_IpRange() {
        setName_IpRange(null);
    }

    public void setName_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda) {
        setName_IpRange("name", opLambda, null);
    }

    public void setName_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setName_IpRange("name", opLambda, aggsLambda);
    }

    public void setName_IpRange(String name, ConditionOptionCall<IPv4RangeBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        IPv4RangeBuilder builder = regIpRangeA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setName_Count() {
        setName_Count(null);
    }

    public void setName_Count(ConditionOptionCall<ValueCountBuilder> opLambda) {
        setName_Count("name", opLambda);
    }

    public void setName_Count(String name, ConditionOptionCall<ValueCountBuilder> opLambda) {
        ValueCountBuilder builder = regCountA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setName_Cardinality() {
        setName_Cardinality(null);
    }

    public void setName_Cardinality(ConditionOptionCall<CardinalityBuilder> opLambda) {
        setName_Cardinality("name", opLambda);
    }

    public void setName_Cardinality(String name, ConditionOptionCall<CardinalityBuilder> opLambda) {
        CardinalityBuilder builder = regCardinalityA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setName_Missing() {
        setName_Missing(null);
    }

    public void setName_Missing(ConditionOptionCall<MissingBuilder> opLambda) {
        setName_Missing("name", opLambda, null);
    }

    public void setName_Missing(ConditionOptionCall<MissingBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setName_Missing("name", opLambda, aggsLambda);
    }

    public void setName_Missing(String name, ConditionOptionCall<MissingBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        MissingBuilder builder = regMissingA(name, "name");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    // String searchLogId

    public void setSearchLogId_Terms() {
        setSearchLogId_Terms(null);
    }

    public void setSearchLogId_Terms(ConditionOptionCall<TermsBuilder> opLambda) {
        setSearchLogId_Terms("searchLogId", opLambda, null);
    }

    public void setSearchLogId_Terms(ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setSearchLogId_Terms("searchLogId", opLambda, aggsLambda);
    }

    public void setSearchLogId_Terms(String name, ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        TermsBuilder builder = regTermsA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setSearchLogId_SignificantTerms() {
        setSearchLogId_SignificantTerms(null);
    }

    public void setSearchLogId_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda) {
        setSearchLogId_SignificantTerms("searchLogId", opLambda, null);
    }

    public void setSearchLogId_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setSearchLogId_SignificantTerms("searchLogId", opLambda, aggsLambda);
    }

    public void setSearchLogId_SignificantTerms(String name, ConditionOptionCall<SignificantTermsBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        SignificantTermsBuilder builder = regSignificantTermsA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setSearchLogId_IpRange() {
        setSearchLogId_IpRange(null);
    }

    public void setSearchLogId_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda) {
        setSearchLogId_IpRange("searchLogId", opLambda, null);
    }

    public void setSearchLogId_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setSearchLogId_IpRange("searchLogId", opLambda, aggsLambda);
    }

    public void setSearchLogId_IpRange(String name, ConditionOptionCall<IPv4RangeBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        IPv4RangeBuilder builder = regIpRangeA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setSearchLogId_Count() {
        setSearchLogId_Count(null);
    }

    public void setSearchLogId_Count(ConditionOptionCall<ValueCountBuilder> opLambda) {
        setSearchLogId_Count("searchLogId", opLambda);
    }

    public void setSearchLogId_Count(String name, ConditionOptionCall<ValueCountBuilder> opLambda) {
        ValueCountBuilder builder = regCountA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setSearchLogId_Cardinality() {
        setSearchLogId_Cardinality(null);
    }

    public void setSearchLogId_Cardinality(ConditionOptionCall<CardinalityBuilder> opLambda) {
        setSearchLogId_Cardinality("searchLogId", opLambda);
    }

    public void setSearchLogId_Cardinality(String name, ConditionOptionCall<CardinalityBuilder> opLambda) {
        CardinalityBuilder builder = regCardinalityA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setSearchLogId_Missing() {
        setSearchLogId_Missing(null);
    }

    public void setSearchLogId_Missing(ConditionOptionCall<MissingBuilder> opLambda) {
        setSearchLogId_Missing("searchLogId", opLambda, null);
    }

    public void setSearchLogId_Missing(ConditionOptionCall<MissingBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setSearchLogId_Missing("searchLogId", opLambda, aggsLambda);
    }

    public void setSearchLogId_Missing(String name, ConditionOptionCall<MissingBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        MissingBuilder builder = regMissingA(name, "searchLogId");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    // String value

    public void setValue_Terms() {
        setValue_Terms(null);
    }

    public void setValue_Terms(ConditionOptionCall<TermsBuilder> opLambda) {
        setValue_Terms("value", opLambda, null);
    }

    public void setValue_Terms(ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setValue_Terms("value", opLambda, aggsLambda);
    }

    public void setValue_Terms(String name, ConditionOptionCall<TermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        TermsBuilder builder = regTermsA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setValue_SignificantTerms() {
        setValue_SignificantTerms(null);
    }

    public void setValue_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda) {
        setValue_SignificantTerms("value", opLambda, null);
    }

    public void setValue_SignificantTerms(ConditionOptionCall<SignificantTermsBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setValue_SignificantTerms("value", opLambda, aggsLambda);
    }

    public void setValue_SignificantTerms(String name, ConditionOptionCall<SignificantTermsBuilder> opLambda,
            OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        SignificantTermsBuilder builder = regSignificantTermsA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setValue_IpRange() {
        setValue_IpRange(null);
    }

    public void setValue_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda) {
        setValue_IpRange("value", opLambda, null);
    }

    public void setValue_IpRange(ConditionOptionCall<IPv4RangeBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setValue_IpRange("value", opLambda, aggsLambda);
    }

    public void setValue_IpRange(String name, ConditionOptionCall<IPv4RangeBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        IPv4RangeBuilder builder = regIpRangeA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

    public void setValue_Count() {
        setValue_Count(null);
    }

    public void setValue_Count(ConditionOptionCall<ValueCountBuilder> opLambda) {
        setValue_Count("value", opLambda);
    }

    public void setValue_Count(String name, ConditionOptionCall<ValueCountBuilder> opLambda) {
        ValueCountBuilder builder = regCountA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setValue_Cardinality() {
        setValue_Cardinality(null);
    }

    public void setValue_Cardinality(ConditionOptionCall<CardinalityBuilder> opLambda) {
        setValue_Cardinality("value", opLambda);
    }

    public void setValue_Cardinality(String name, ConditionOptionCall<CardinalityBuilder> opLambda) {
        CardinalityBuilder builder = regCardinalityA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
    }

    public void setValue_Missing() {
        setValue_Missing(null);
    }

    public void setValue_Missing(ConditionOptionCall<MissingBuilder> opLambda) {
        setValue_Missing("value", opLambda, null);
    }

    public void setValue_Missing(ConditionOptionCall<MissingBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        setValue_Missing("value", opLambda, aggsLambda);
    }

    public void setValue_Missing(String name, ConditionOptionCall<MissingBuilder> opLambda, OperatorCall<BsSearchFieldLogCA> aggsLambda) {
        MissingBuilder builder = regMissingA(name, "value");
        if (opLambda != null) {
            opLambda.callback(builder);
        }
        if (aggsLambda != null) {
            SearchFieldLogCA ca = new SearchFieldLogCA();
            aggsLambda.callback(ca);
            ca.getAggregationBuilderList().forEach(builder::subAggregation);
        }
    }

}
